## gnu.crypto.prng
Interface IRandomStandalone

All Superinterfaces:
  Cloneable

All Known Implementing Classes:
  AsyncFortunaStandalone, BasePRNGStandalone, FortunaStandalone, FortunaStandalone.Generator

    public interface IRandomStandalone

extends Cloneable

The basic visible methods of any pseudo-random number generator.

The [HAC] defines a PRNG (as implemented in this library) as follows:

- "5.6 Definition: A pseudorandom bit generator (PRBG) is said to pass the next-bit test if there is no polynomial-time algorithm which, on input of the first `L` bits of an output sequence `S`, can predict the `(L+1)`st bit of `S` with a probability significantly grater than `1/2`."
- "5.8 Definition: A PRBG that passes the next-bit test (possibly under some plausible but unproved mathematical assumption such as the intractability of factoring integers) is called a cryptographically secure pseudorandom bit generator (CSPRBG)."

IMPLEMENTATION NOTE: Although all the concrete classes in this package implement the `Cloneable` interface, it is important to note here that such an operation, for those algorithms that use an underlting symmetric key block cipher, DOES NOT clone any session key material that may have been used in initialising the source PRNG (the instance to be cloned). Instead a clone of an already initialised PRNG, that uses and underlying symmetric key block cipher, is another instance with a clone of the same cipher that operates with the same block size but without any knowledge of neither key material nor key size.

References:

1. [HAC]: Handbook of Applied Cryptography.
   CRC Press, Inc. ISBN 0-8493-8523-7, 1997
   Menezes, A., van Oorschot, P. and S. Vanstone.

Version:
  $Revision: 1.1 $

Method Summary
`void` `addRandomByte(byte b)` Supplement, or possibly replace, the random state of this PRNG with a random byte.
`void` `addRandomBytes(byte[] in)` Supplement, or possibly replace, the random state of this PRNG with a sequence of new random bytes.
`void` `addRandomBytes(byte[] in, int offset, int length)` Supplement, or possibly replace, the random state of this PRNG with a sequence of new random bytes.
`Object` `clone()` Returns a clone copy of this instance.
`void` `init(Map attributes)` Initialises the pseudo-random number generator scheme with the appropriate attributes.
`String` `name()` Returns the canonical name of this instance.
`byte` `nextByte()` Returns the next 8 bits of random data generated from this instance.
`void` `nextBytes(byte[] out, int offset, int length)` Fills the designated byte array, starting from byte at index `offset`, for a maximum of `length` bytes with the output of this generator instance.

Method Detail

### name

    String name()

  Returns the canonical name of this instance.

  Returns:
    the canonical name of this instance.

### init

    void init(Map attributes)

  Initialises the pseudo-random number generator scheme with the appropriate attributes.

  Parameters:
    `attributes` - a set of name-value pairs that describe the desired future instance behaviour.
  Throws:
    `IllegalArgumentException` - if at least one of the defined name/ value pairs contains invalid data.

### nextByte

    byte nextByte()
                  throws IllegalStateException,
                         LimitReachedExceptionStandalone

  Returns the next 8 bits of random data generated from this instance.

  Returns:
    the next 8 bits of random data generated from this instance.
  Throws:
    `IllegalStateException` - if the instance is not yet initialised.
    `LimLimitReachedExceptionStandalone` - this instance has reached its theoretical limit for generating non-repetitive pseudo-random data.
    `LimitReachedExceptionStandalone`

### nextBytes

    void nextBytes(byte[] out,
                   int offset,
                   int length)
                   throws IllegalStateException,
                          LimitReachedExceptionStandalone

  Fills the designated byte array, starting from byte at index `offset`, for a maximum of `length` bytes with the output of this generator instance.

  Parameters:
    `out` - the placeholder to contain the generated random bytes.
    `offset` - the starting index in out to consider. This method does nothing if this parameter is not within `0` and `out.length`.
    `length` - the maximum number of required random bytes. This method does nothing if this parameter is less than `1`.
  Throws:
    `IllegalStateException` - if the instance is not yet initialised.
    `LimitLimitReachedExceptionStandalonehis` - instance has reached its theoretical limit for generating non-repetitive pseudo-random data.
    `LimitReachedExceptionStandalone`

### addRandomByte

    void addRandomByte(byte b)

  Supplement, or possibly replace, the random state of this PRNG with a random byte.

  Implementations are not required to implement this method in any meaningful way; this may be a no-operation, and implementations may throw an `UnsupportedOperationException`.

  Parameters:
    `b` - The byte to add.

### addRandomBytes

    void addRandomBytes(byte[] in)

  Supplement, or possibly replace, the random state of this PRNG with a sequence of new random bytes.

  Implementations are not required to implement this method in any meaningful way; this may be a no-operation, and implementations may throw an `UnsupportedOperationException`.

  Parameters:
    `in` - The buffer of new random bytes to add.

### addRandomBytes

    void addRandomBytes(byte[] in,
                        int offset,
                        int length)

  Supplement, or possibly replace, the random state of this PRNG with a sequence of new random bytes.

  Implementations are not required to implement this method in any meaningful way; this may be a no-operation, and implementations may throw an `UnsupportedOperationException`.

  Parameters:
    `in` - The buffer of new random bytes to add.
    `offset` - The offset from whence to begin reading random bytes.
    `length` - The number of random bytes to add.
  Throws:
    `IndexOutOfBoundsException` - If offset, length, or offset+length is out of bounds.

### clone

    Object clone()
                 throws CloneNotSupportedException

  Returns a clone copy of this instance.

  Returns:
    a clone copy of this instance.
  Throws:
    `CloneNotSupportedException`